<?php
/**
 *
 * This file implements the real_tagcloud plugin for {@link http://b2evolution.net/}.
 *
 * @copyright (c)2006 by Tears - {@link http://blog.dead-black-rose.de/}.
 *
 * @license GNU General Public License 2 (GPL) - http://www.opensource.org/licenses/gpl-license.php
 *
 * @package plugins
 *
 * @author Tears (Thomas Heger)
 *
 * @version $Id: read_tagcloud 1.0
 */
if( !defined('EVO_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

/**
 * PLUGIN_NAME Plugin
 *
 * Some description
 *
 * @package plugins
 */

class realtagcloud_plugin extends Plugin
{

	/**
	 * Variables below MUST be overriden by plugin implementations,
	 * either in the subclass declaration or in the subclass constructor.
	 */
	var $name = 'Real Tagcloud';
	/**
	 * Code, if this is a renderer or pingback plugin.
	 */
	var $code = 'real_tagcloud';
	var $priority = 50;
	var $version = '2.0';
	var $author = 'http://blog.dead-black-rose.de/';
	var $help_url = '';
	var $group = 'widget';
	var $apply_rendering = 'never';



	/**
	 * Init
	 *
	 * This gets called after a plugin has been registered/instantiated.
	 */
	function PluginInit( & $params )
	{
		$this->name = $this->T_('Real Tag Cloud');
		$this->short_desc = $this->T_('Display a tagcloud');
		$this->long_desc = $this->T_('Displays a real tagcloud based on the inserted tags');
	}

	function SkinTag( $params ) {
		global $DB;
		global $Blog;

		if($this->Settings->get( 'max_items' ) == "")
		{
			$max_items = 10;
		}
		else
		{
			$max_items = $this->Settings->get( 'max_items' );
		}

		/**
		 * Let's fetch the most used tags
		 */
		$Blog->ID;

		/*$sql_cats = 'SELECT cat_ID
		FROM T_categories
		WHERE cat_blog_ID= ' . $Blog->ID;

		$cat_list = $DB->get_results( $sql_cats );

		$sql_entries = 'SELECT cat_ID
		FROM T_categories
		WHERE post_main_cat_ID= ' . $Blog->ID;*/


		$sql = 'SELECT count(*) AS tag_total, tag_name 
		FROM T_items__itemtag 
		JOIN ( T_items__tag ) ON ( itag_tag_ID = tag_ID ) 
		JOIN ( T_items__item ) ON ( itag_itm_ID = post_ID )
		JOIN ( T_categories ) ON ( cat_ID = post_main_cat_ID )
		WHERE cat_blog_ID = ' . $Blog->ID . '
		GROUP BY tag_ID 
		ORDER BY tag_total DESC 
		LIMIT ' . $max_items;


		#$sql = 'SELECT count(*) AS tag_total, tag_name FROM T_items__itemtag JOIN ( T_items__tag ) ON ( itag_tag_ID = tag_ID ) GROUP BY tag_ID ORDER BY tag_total DESC LIMIT ' . $max_items; 
		
		if( $tags = $DB->get_results( $sql ) ) 
		{ 
			echo '<div id="realtagcloud">';
			
			/**
			 * Give us a title is there is one
			 */
			if($this->Settings->get('title') !== '')
			{
				echo '<h2>' . $this->Settings->get('title') . '</h2>';
			}
			
			$max = 0;
			
			/**
			 * Sort the tags and get minimum and maximum of the times they are used
			 */
			foreach( $tags as $tag ) 
			{
				$taglist[$tag->tag_name]['name'] = $tag->tag_name;
				$taglist[$tag->tag_name]['count'] = $tag->tag_total;
				if($tag->tag_total>$max) 
				{
					$max = $tag->tag_total;
				}
				if(!isset($min) || $tag->tag_total<$min) {
					$min = $tag->tag_total;
				}
				
			}
			array_multisort($taglist, SORT_REGULAR);

			$fontmin = $this->Settings->get( 'font_min' );
			$fontdelta = $this->Settings->get( 'font_max' ) - $fontmin;


			/**
			 * Check if there is a query-string and switch between & and ?
			 */			
			$blogurl_parsed = parse_url($Blog->gen_blogurl());
			if(!isset($blogurl_parsed["query"])) {
				$query_sign = '?';
			}else{
				$query_sign = '&';
			}
			
			/**
			 * Lets start the output of the tags
			 */
			foreach($taglist as $stag) 
			{
				$num = $fontmin + round($fontdelta * (($stag['count']-$min)*100/$max) / 100);
				echo '<span  style="font-size: ' . $num . '%;"><a href="' . $Blog->gen_blogurl(). $query_sign . 'tag='.$stag['name'].'" ';
				if($this->Settings->get('robotfollow') == 1)
				{
					echo 'rel="nofollow" ';
				}
				echo 'title="view all posts tagged with '.$stag['name'].'">'.$stag['name'].'</a></span> ';
			}
			if($this->Settings->get('credits') == 1)
			{
				echo '<p>TagCloud by <a href="http://blog.dead-black-rose.de" target="_blank">Tears</a></p>';
			}
						
			echo '</div>';
		}
	}


	/**
	 * Define settings that the plugin uses/provides.
	 */
	function GetDefaultSettings()
	{
		return array(
			'title' => array (
				'label' => $this->T_('Title'),
				'defaultvalue' => '',
				'note' => $this->T_('Shows a Title over the TagCloud')),
			'font_min' => array(
				'label' => $this->T_( 'Minimum font size' ),
				'defaultvalue' => 90,
				'note' => $this->T_('Minimum font size for the TagCloud (in percent)')),
			'font_max' => array(
				'label' => $this->T_( 'Maxmimum Font Size' ),
				'defaultvalue' => 300,
				'note' => $this->T_('Maximum font size for the TagCloud (in percent)')),
			'max_items' => array (
				'label' => $this->T_('Maximum Tags to display'),
				'defaultvalue' => 10,
				'type' => 'integer',
				'note' => $this->T_('Donnot make this to big')),
			'robotfollow' => array (
				'label' => $this->T_('Robots do not follow Tag Cloud-Links?'),
				'defaultvalue' => 0,
				'type' => 'checkbox',
				'note' => $this->T_('If active rel="nofollow" will be added to Links in the Tag Cloud')),
			'credits' => array (
				'label' => $this->T_('Show credits with a link to Tears'),
				'defaultvalue' => 1,
				'type' => 'checkbox',
				'note' => $this->T_('If active a credit link will appear under the tagcloud')),
			);
	}

	/**
	 * Define user settings that the plugin uses/provides.
	 */
	function GetDefaultUserSettings()
	{
		return array(

			);
	}
}
?>